import java.util.PriorityQueue;
import java.util.ArrayList;

/**
 * Beschreiben Sie hier die Klasse Suche.
 * 
 * @author (Ihr Name) 
 * @version (eine Versionsnummer oder ein Datum)
 */
public class Suche_A_Stern
{
    private Feld start, ziel;
    private Weg aktuellerWeg;
    private PriorityQueue<Weg> wege;
    private Weg ergebnis;
    
    /**
     * Konstruktor für Objekte der Klasse Suche_A_Stern
     */
    public Suche_A_Stern()
    {
        erzeugeSuchFeld(10);
        start = Feld.gibFeld(9,6);
        ziel = Feld.gibFeld(1,4);
        initialisiereSuche();
    }

    /**
     * Konstruktor für Objekte der Klasse Suche_A_Stern
     */
    public Suche_A_Stern(boolean klein)
    {
        if (klein)
        {
            Feld.erzeugeFelder(5);
            start = Feld.gibFeld(1,1);
            ziel = Feld.gibFeld(5,1);
            Feld.sperre(2, 1);
            Feld.sperre(3, 2);
        }
        else
        {
            Feld.erzeugeFelder(6);
            start = Feld.gibFeld(1,1);
            ziel = Feld.gibFeld(6,1);
            Feld.sperre(2, 2);
            Feld.sperre(3, 2);
            Feld.sperre(4, 2);
            Feld.sperre(5, 2);
            Feld.sperre(5, 1);
            Feld.sperre(4, 3);
            Feld.sperre(4, 4);
        }
        initialisiereSuche();
    }

    /**
     * Konstruktor für Objekte der Klasse Suche_A_Stern
     * mit variabler Kantenlaenge ab 9
     */
    public Suche_A_Stern(int kantenlaenge)
    {
        if (kantenlaenge<9) kantenlaenge = 9;
        erzeugeSuchFeld(kantenlaenge);
        start = Feld.gibFeld(9,6);
        ziel = Feld.gibFeld(1,4);
        initialisiereSuche();
    }

    /**
     * initialisiert die Suche
     */
    private void initialisiereSuche()
    {
        aktuellerWeg = new Weg(start, ziel);
        wege = new PriorityQueue();
        wege.add(aktuellerWeg);
        start.besucht();
        start.beschrifte("S");
        ziel.beschrifte("Z");
        ergebnis = null;
    }
    
    /**
     * fuehrt die Suche automatisch durch
     */
    public Weg suche()
    {
        while (ergebnis==null)
        {
            suchSchritt();
            Leinwand.gibLeinwand().warte(500);
        }
        return ergebnis;
    }

    /**
     * Fuehrt einen Expansionsschritt aus
     */
    public void suchSchritt()
    {
        if (wege.isEmpty()) return;
        if (ergebnis!=null)
        {
            zeigeSuchergebnis();
            return;
        }
        aktuellerWeg = wege.poll();
        Feld aktuell = aktuellerWeg.gibLetzten();
            // Zum Verfolgen:
            //            System.out.print("aktueller Weg:");
            //            aktuellerWeg.zeigeWeg();
            //            System.out.println("Anzahl restlicher Wege:"+wege.size());
            //            for (Weg weg : wege) weg.zeigeWeg();

            Weg neuerWeg;
            ArrayList<Feld> nachbarn = Feld.gibNachbarn(aktuell);
            for (Feld feld : nachbarn)
            if (!feld.istGesperrt())
            if (!feld.istBesucht())
            if (!aktuellerWeg.vorhanden(feld))
            {
                feld.besucht();
                neuerWeg = new Weg(aktuellerWeg, feld);
                wege.add(neuerWeg);
                if (feld.equals(ziel))
                {
                    ergebnis = neuerWeg;
                    return;
                }
                feld.beschrifte(""+neuerWeg.gesamtKosten());
            
        }
    }


    /**
     * zeiget das Suchergebnis nach Durchfuehren der Suche an
     */
    public void zeigeSuchergebnis()
    {
        if (ergebnis!=null) 
        {
            System.out.println("Suchergebnis :");
            ergebnis.zeigeWeg();
        }
        else System.out.println("Kein Weg gefunden");
    }

    /**
     * erzeugt das Startfeld
     */
    public void erzeugeSuchFeld(int kantenlaenge)
    {
        Feld.erzeugeFelder(kantenlaenge);
        Feld.sperre(1, 2);
        Feld.sperre(1, 6);
        Feld.sperre(2, 2);
        Feld.sperre(2, 3);
        Feld.sperre(2, 4);
        Feld.sperre(2, 6);
        Feld.sperre(2, 8);
        Feld.sperre(2, 9);
        Feld.sperre(3, 2);
        Feld.sperre(3, 6);
        Feld.sperre(3, 8);
        Feld.sperre(3, 9);
        Feld.sperre(4, 6);
        Feld.sperre(4, 9);
        Feld.sperre(6, 3);
        Feld.sperre(6, 4);
        Feld.sperre(6, 5);
        Feld.sperre(6, 6);
        Feld.sperre(7, 3);
        Feld.sperre(7, 7);
        Feld.sperre(8, 3);
        Feld.sperre(8, 7);
        Feld.gibFeld(1,4).beschrifte("Z");
        Feld.gibFeld(9,6).beschrifte("S");
    }

}
