import java.util.LinkedList;

/**
 * Beschreibt Wege im Schachbrettfeld
 * 
 * @author claus albowski
 * @version juni 2015
 */
public class Weg
implements Comparable
{
    private LinkedList<Feld> felder;
    private static Feld start, ziel;

    public Weg(Feld start, Feld ziel)
    {
        felder = new LinkedList();
        this.start = start;
        this.ziel = ziel;
        felder.add(start);
    }

    /**
     * Konstruktor fuer eine Kopie mit Verlaengerung
     */
    public Weg(Weg weg, Feld neu)
    {
        felder = new LinkedList();
        for (Feld feld : weg.gibFelder()) anhaengen(feld);
        anhaengen(neu);
    }
    
    /**
     * notwendige Methode fuer das Interface Comparable
     */
    public int compareTo(Object obj)
    {
        Weg anderer = (Weg) obj;
        return gesamtKosten() - anderer.gesamtKosten();
    }

    public LinkedList<Feld> gibFelder() { return felder; }

    public Feld gibLetzten() { return felder.getLast(); }

    public void anhaengen(Feld naechsten) { felder.addLast(naechsten); }

    public boolean vorhanden(Feld untersucht) { return felder.contains(untersucht); }

    /**
     * berechnet die Gesamtkosten des Weges
     */
    public int gesamtKosten()
    {
        return aktuelleKosten()+restKosten();
    }

    /**
     * berechnet die aktuellen Kosten des Weges aus der 
     * Anzahl der besuchten Felder
     */
    public int aktuelleKosten()
    {
        return felder.size() - 1;
    }

    /**
     * berechnet die Restkosten des Weges
     */
    public int restKosten()
    {
        return ziel.manhattanDistanz(gibLetzten());
    }

    /**
     * zeigt den Weg in der Konsole an
     */
    public void zeigeWeg()
    {
        for (Feld feld : felder)
        System.out.println("( "+feld.gibZeile()+" / "+feld.gibSpalte()+" )");
        System.out.println(" ");
    }
    
}

